package awais.instagrabber;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Resources;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.WindowManager;
import android.widget.Toast;

import java.io.File;

import awais.instagrabber.asyncs.DownloadAsync;
import awais.instagrabber.asyncs.PostFetcher;
import awais.instagrabber.models.ClipModel;
import awais.instagrabber.models.ViewerPostModel;
import awais.instagrabber.utils.Utils;

public class DirectDownload extends Activity {
    private boolean isFound = false;
    private Intent intent;
    private Context context;

    @Override
    public void onWindowAttributesChanged(final WindowManager.LayoutParams params) {
        super.onWindowAttributesChanged(params);
        if (!isFound) {
            intent = getIntent();
            context = getApplicationContext();
            if (intent != null && context != null) {
                isFound = true;
                checkIntent();
//                new PenisAsync(intent).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, context);
                finish();
            }
        }
    }

    @Override
    public Resources getResources() {
        if (!isFound) {
            intent = getIntent();
            context = getApplicationContext();
            if (intent != null && context != null) {
                Log.d("AWAISKING_APP", "getResources:" + getApplicationContext());
                isFound = true;
                checkIntent();
//                new PenisAsync(intent).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, context);
                finish();
            }
        }
        return super.getResources();
    }

    private void checkIntent() {
        final String action = intent.getAction();
        if (!Utils.isEmpty(action) && !"android.intent.action.MAIN".equals(action)) {
            boolean error = true;

            String data = null;
            final Bundle extras = intent.getExtras();
            if (extras != null) {
                final Object extraData = extras.get(Intent.EXTRA_TEXT);
                if (extraData != null) {
                    error = false;
                    data = extraData.toString();
                }
            }

            if (error) {
                final Uri intentData = intent.getData();
                if (intentData != null) data = intentData.toString();
            }

            if (data != null && !Utils.isEmpty(data)) {
                final ClipModel model = Utils.stripString(data);
                if (model != null && model.isPost()) {
                    final String text = model.getText();
                    Log.d("AWAISKING_APP", "text: " + text);
                    new PostFetcher(text, result -> {
                        if (result != null && result.length > 0) {
                            final File dir = new File(Environment.getExternalStorageDirectory(), "Download");
                            if (dir.exists() || dir.mkdirs()) {
                                final ViewerPostModel postModel = result[0];

                                final String displayUrl = postModel.getDisplayUrl();
                                final int index = displayUrl.indexOf('?');
                                final File file = new File(dir, postModel.getPostId() + "_" + postModel.getTimestamp()
                                        + displayUrl.substring(index - 4, index));

                                Toast.makeText(context, "Downloading post.", Toast.LENGTH_SHORT).show();

                                new DownloadAsync(context, displayUrl, file, fileResult -> {
                                    if (fileResult == null || !fileResult.exists()) {
                                        Toast.makeText(context, "Error downloading file", Toast.LENGTH_SHORT).show();
                                    } else if (fileResult.exists()) {
                                        Toast.makeText(context, "Post downloaded!!", Toast.LENGTH_SHORT).show();
                                    }
                                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                            }
                        }
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            }
        }
    }
}