package awais.instagrabber.asyncs;

import android.os.AsyncTask;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONObject;

import java.net.HttpURLConnection;
import java.net.URL;

import awais.instagrabber.interfaces.FetchListener;
import awais.instagrabber.models.SuggestionModel;
import awais.instagrabber.utils.Utils;

public class SuggestionsAsync extends AsyncTask<String, String, String> {
    private final FetchListener<SuggestionModel[]> fetchListener;
    private HttpURLConnection conn;

    public SuggestionsAsync(FetchListener<SuggestionModel[]> fetchListener) {
        this.fetchListener = fetchListener;
    }

    @Override
    protected String doInBackground(String... params) {
        try {
            conn = (HttpURLConnection) new URL("https://www.instagram.com/web/search/topsearch/?context=blended&count=70&query="
                    + params[0]).openConnection();
            conn.setReadTimeout(31717);
            conn.setConnectTimeout(31717);
            conn.setDoOutput(true);
            conn.connect();

            if (conn.getResponseCode() == HttpURLConnection.HTTP_OK)
                return Utils.readFromConnection(conn);
        } catch (Exception e) {
            Log.e("AWAISKING_APP", "", e);
        } finally {
            if (conn != null) conn.disconnect();
        }
        return null;
    }

    @Override
    protected void onPostExecute(String result) {
        if (result == null) return;

        try {
            final JSONArray jsonArray = new JSONObject(result).getJSONArray("result");

            final SuggestionModel[] suggestionModels = new SuggestionModel[jsonArray.length()];

            for (int i = 0; i < suggestionModels.length; i++) {
                final JSONObject user = jsonArray.getJSONObject(i).getJSONObject("user");
                suggestionModels[i] = new SuggestionModel(user.getBoolean("is_private"), user.getBoolean("is_verified"),
                        user.getString("pk"), user.getString("username"), user.getString("full_name"),
                        user.getString("profile_pic_url"));
            }

            fetchListener.onResult(suggestionModels);
        } catch (Exception e) {
            Log.e("AWAISKING_APP", "JSON", e);
        }
    }
}