package awais.instagrabber.models;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.NonNull;

public final class PostModel implements Parcelable {
    public static final Creator<PostModel> CREATOR = new Creator<PostModel>() {
        @NonNull
        @Override
        public PostModel createFromParcel(Parcel in) {
            return new PostModel(in);
        }

        @NonNull
        @Override
        public PostModel[] newArray(int size) {
            return new PostModel[size];
        }
    };
    private String postCaption, postId, endCursor;
    private final String displayUrl, thumbnailUrl, shortCode;
    private final boolean isVideo;
    private boolean hasNextPage, isSelected, isSlider;
    private long timestamp;
    private int position;

    public PostModel(final boolean isVideo, final String postId, final String displayUrl, final String thumbnailUrl,
                     final String shortCode, final String postCaption, long timestamp) {
        this.isVideo = isVideo;
        this.postId = postId;
        this.displayUrl = displayUrl;
        this.thumbnailUrl = thumbnailUrl;
        this.shortCode = shortCode;
        this.postCaption = postCaption;
        this.timestamp = timestamp;
    }

    public int getPosition() {
        return position;
    }

    public boolean isSelected() {
        return isSelected;
    }

    public boolean isVideo() {
        return isVideo;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public String getPostId() {
        return postId;
    }

    public String getDisplayUrl() {
        return displayUrl;
    }

    public String getThumbnailUrl() {
        return thumbnailUrl;
    }

    public String getShortCode() {
        return shortCode;
    }

    public String getPostCaption() {
        return postCaption;
    }

    public String getEndCursor() {
        return endCursor;
    }

    public boolean hasNextPage() {
        return endCursor != null && hasNextPage;
    }

    public boolean isSlider() {
        return isSlider;
    }

    public void setPostId(final String postId) {
        this.postId = postId;
    }

    public void setPostCaption(final String postCaption) {
        this.postCaption = postCaption;
    }

    public void setTimestamp(final long timestamp) {
        this.timestamp = timestamp;
    }

    public void setPosition(final int position) {
        this.position = position;
    }

    public void setSelected(final boolean selected) {
        this.isSelected = selected;
    }

    public void setSlider(final boolean slider) {
        isSlider = slider;
    }

    public void setPageCursor(final boolean hasNextPage, final String endCursor) {
        this.endCursor = endCursor;
        this.hasNextPage = hasNextPage;
    }

    private PostModel(@NonNull Parcel in) {
        isVideo = in.readByte() != 0;
        timestamp = in.readLong();
        postId = in.readString();
        displayUrl = in.readString();
        thumbnailUrl = in.readString();
        shortCode = in.readString();
        postCaption = in.readString();
        endCursor = in.readString();
        hasNextPage = in.readByte() != 0;
    }

    @Override
    public void writeToParcel(@NonNull final Parcel dest, final int flags) {
        dest.writeByte((byte) (isVideo ? 1 : 0));
        dest.writeLong(timestamp);
        dest.writeString(postId);
        dest.writeString(displayUrl);
        dest.writeString(thumbnailUrl);
        dest.writeString(shortCode);
        dest.writeString(postCaption);
        dest.writeString(endCursor);
        dest.writeByte((byte) (hasNextPage ? 1 : 0));
    }

    @Override
    public int describeContents() {
        return 0;
    }
}