package awais.instagrabber.models;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.NonNull;

public class ProfileModel implements Parcelable {
    public static final Creator<ProfileModel> CREATOR = new Creator<ProfileModel>() {
        @NonNull
        @Override
        public ProfileModel createFromParcel(Parcel in) {
            return new ProfileModel(in);
        }

        @NonNull
        @Override
        public ProfileModel[] newArray(int size) {
            return new ProfileModel[size];
        }
    };
    private final boolean isPrivate, isVerified;
    private final String id, username, name, biography, sdProfilePic, hdProfilePic;
    private final long postCount, followersCount, followingCount;

    public ProfileModel(final boolean isPrivate, final boolean isVerified, final String id, final String username,
                        final String name, final String biography, final String sdProfilePic, final String hdProfilePic,
                        final long postCount, final long followersCount, final long followingCount) {
        this.isPrivate = isPrivate;
        this.isVerified = isVerified;
        this.id = id;
        this.username = username;
        this.name = name;
        this.biography = biography;
        this.sdProfilePic = sdProfilePic;
        this.hdProfilePic = hdProfilePic;
        this.postCount = postCount;
        this.followersCount = followersCount;
        this.followingCount = followingCount;
    }

    public boolean isPrivate() {
        return isPrivate;
    }

    public boolean isVerified() {
        return isVerified;
    }

    public String getId() {
        return id;
    }

    public String getUsername() {
        return username;
    }

    public String getName() {
        return name;
    }

    public String getBiography() {
        return biography;
    }

    public String getSdProfilePic() {
        return sdProfilePic;
    }

    public String getHdProfilePic() {
        return hdProfilePic;
    }

    public long getPostCount() {
        return postCount;
    }

    public long getFollowersCount() {
        return followersCount;
    }

    public long getFollowingCount() {
        return followingCount;
    }

    private ProfileModel(@NonNull Parcel in) {
        isPrivate = in.readByte() != 0;
        isVerified = in.readByte() != 0;
        id = in.readString();
        username = in.readString();
        name = in.readString();
        biography = in.readString();
        sdProfilePic = in.readString();
        hdProfilePic = in.readString();
        postCount = in.readLong();
        followersCount = in.readLong();
        followingCount = in.readLong();
    }

    @Override
    public void writeToParcel(@NonNull final Parcel dest, final int flags) {
        dest.writeByte((byte) (isPrivate ? 1 : 0));
        dest.writeByte((byte) (isVerified ? 1 : 0));
        dest.writeString(id);
        dest.writeString(username);
        dest.writeString(name);
        dest.writeString(biography);
        dest.writeString(sdProfilePic);
        dest.writeString(hdProfilePic);
        dest.writeLong(postCount);
        dest.writeLong(followersCount);
        dest.writeLong(followingCount);
    }

    @Override
    public int describeContents() {
        return 0;
    }
}