package awais.instagrabber.models;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.NonNull;

public class StoryModel implements Parcelable {
    public static final Creator<StoryModel> CREATOR = new Creator<StoryModel>() {
        @NonNull
        @Override
        public StoryModel createFromParcel(Parcel in) {
            return new StoryModel(in);
        }

        @NonNull
        @Override
        public StoryModel[] newArray(int size) {
            return new StoryModel[size];
        }
    };
    private final String storyMediaId, storyUrl;
    private final boolean isVideo;
    private final long timestamp;
    private String videoUrl;

    public StoryModel(final String storyMediaId, final String storyUrl, final boolean isVideo, final long timestamp) {
        this.storyMediaId = storyMediaId;
        this.storyUrl = storyUrl;
        this.isVideo = isVideo;
        this.timestamp = timestamp;
    }

    protected StoryModel(@NonNull Parcel in) {
        storyMediaId = in.readString();
        storyUrl = in.readString();
        isVideo = in.readByte() != 0;
        timestamp = in.readLong();
        videoUrl = in.readString();
    }

    public String getStoryUrl() {
        return storyUrl;
    }

    public String getStoryMediaId() {
        return storyMediaId;
    }

    public boolean isVideo() {
        return isVideo;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public String getVideoUrl() {
        return videoUrl;
    }

    public void setVideoUrl(final String videoUrl) {
        this.videoUrl = videoUrl;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(final @NonNull Parcel dest, final int flags) {
        dest.writeString(storyMediaId);
        dest.writeString(storyUrl);
        dest.writeByte((byte) (isVideo ? 1 : 0));
        dest.writeLong(timestamp);
        dest.writeString(videoUrl);
    }
}