package awais.instagrabber.utils;

import android.util.Log;
import android.view.GestureDetector;
import android.view.MotionEvent;

public final class SwipeListener extends GestureDetector.SimpleOnGestureListener {
    public static final int SWIPE_THRESHOLD = 100;
    public static final int SWIPE_VELOCITY_THRESHOLD = 100;
    private final SwipeEvent swipeEvent;

    public SwipeListener(final SwipeEvent swipeEvent) {
        this.swipeEvent = swipeEvent;
    }

    @Override
    public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
        try {
            final float diffY = e2.getY() - e1.getY();
            final float diffX = e2.getX() - e1.getX();
            if (Math.abs(diffX) > Math.abs(diffY) && Math.abs(diffX) > SWIPE_THRESHOLD
                    && Math.abs(velocityX) > SWIPE_VELOCITY_THRESHOLD) {
                if (diffX > 0) swipeEvent.onSwipe(true);
                else swipeEvent.onSwipe(false);
                return true;
            }
        } catch (final Exception e) {
            Log.e("AWAISKING_APP", "", e);
        }
        return false;
    }

    public interface SwipeEvent {
        void onSwipe(final boolean isRight);
    }
}
